*******************************************************************************
*   File........: alen3d.prg
*   Date........: September 30, 1993
*   Author......: Ly Minh Tr (CIS 70641,3127)
*   Copyright...: None...freeware!
*   Version.....: 1.02
*******************************************************************************
*   PURPOSE:    Returns the number of elements, rows, columns or widths for
*               a 3D-array
*
*   SYNTAX:     alen3d(<parray> [, <nexp>])
*
*   PARAMETERS: <parray>    = the 3D-array to extract the length from
*               <nexp>      = if 0, alen3d() returns number of elements
*                           = if 1, alen3d() returns number of rows
*                           = if 2, alen3d() returns number of columns
*                           = if 3, alen3d() returns number of widths
*
*   RETURNS:    Numeric
*
*   REMARKS:    Mimics Foxpro's ALEN() for a 3D-array.
*
*   SEE ALSO:   acount3d(), adel3d(), aelem3d(), adim3d(), afill3d(), ains3d(),
*               aloc3d(), astore3d(), asubs3d()
*******************************************************************************
PARAMETERS parray, nexp
PRIVATE nval
EXTERNAL ARRAY parray

nexp = IIF(EMPTY(nexp), 0, nexp)

DO CASE
    CASE !INLIST(PARAMETER(), 1, 2)
        WAIT WINDOW "Invalid number of parameters given!" TIMEOUT 1
        nval = 0

    CASE TYPE("parray[1]") <> "C" OR !([3D] $ parray[1])
        WAIT WINDOW "Given array is not a 3D-array!"
        nval = 0

    CASE TYPE("nexp") <> "N" OR !BETWEEN(nexp, 0, 3)
        WAIT WINDOW "Invalid 2nd parameter given!" TIMEOUT 1
        nval = 0

    CASE nexp == 0
        nval = ALEN(parray) - 1

    CASE nexp == 1
        nval = INT(VAL(SUBSTR(parray[1], 4)))

    CASE nexp == 2
        nval = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 2)+1)))

    CASE nexp == 3
        nval = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 3)+1)))
ENDCASE

RETURN nval
