*******************************************************************************
*   File........: astore3d.prg
*   Date........: September 30, 1993
*   Author......: Ly Minh Tr (CIS 70641,3127)
*   Copyright...: None...freeware!
*   Version.....: 1.02
*******************************************************************************
*   PURPOSE:    astore3d() stores into array <parray> the value <pexp> at
*               element <i>, <j>, <k>
*
*   SYNTAX:     astore3d(<parray>, <i>, <j>, <k>, <pexp>)
*
*   PARAMETERS: <parray>    = the 3D-array to store data into
*               <i>         = subscript for dimension 1
*               <j>         = subscript for dimension 2
*               <k>         = subscript for dimension 3
*               <pexp>      = the data to be stored
*
*   RETURNS:    Boolean     = .T. if successful, .F. if store failed
*
*   SEE ALSO:   acount3d(), adel3d(), aelem3d(), adim3d(), afill3d(), ains3d(),
*               alen3d(), aloc3d(), asubs3d()
*******************************************************************************
PARAMETER parray, i, j, k, pexp
PRIVATE nloc
EXTERNAL ARRAY parray

IF PARAMETER() <> 5
    WAIT WINDOW [Invalid number of parameters given!] TIMEOUT 1
    RETURN .F.
ENDIF

nloc = aloc3d(@parray, i, j, k)         && Get corresponding 1D-array subscript
IF nloc > 0
    parray[nloc] = pexp                 && Store data to parray[]
ENDIF

RETURN nloc > 0
